package com.frontleaves.bungeecross.commands;

import com.frontleaves.bungeecross.BungeeCross;
import com.frontleaves.bungeecross.configuration.ServerEnable;
import com.frontleaves.bungeecross.configuration.VariableStorage;
import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.plugin.Command;
import org.jetbrains.annotations.NotNull;

/**
 * 输出插件基本信息
 *
 * @author 筱锋xiao_lfeng
 */
public class PluginInfoCommand extends Command {

    private final BungeeCross plugin;

    public PluginInfoCommand(String name, BungeeCross bungeeCross) {
        super(name);
        plugin = bungeeCross;
    }

    @Override
    public void execute(@NotNull CommandSender commandSender, String @NotNull [] strings) {
        switch (strings.length) {
            case 1: {
                if ("reload".equals(strings[0])) {
                    if (commandSender.hasPermission("bungeecross.admin")) {
                        ServerEnable serverEnable = new ServerEnable(plugin);
                        serverEnable.serverReload();
                    } else {
                        commandSender.sendMessage(VariableStorage.getPrefix() + "您不是管理员，无法进行操作");
                    }
                } else if ("update".equals(strings[0])) {
                    if (commandSender.hasPermission("bungeecross.admin")) {
                        commandSender.sendMessage(VariableStorage.getPrefix() + "您的版本为最新的 " + BungeeCross.getVersion());
                    } else {
                        commandSender.sendMessage(VariableStorage.getPrefix() + "您不是管理员，无法进行操作");
                    }
                } else {
                    commandSender.sendMessage(VariableStorage.getPrefix() + "参数无效");
                }
            }
            break;
            default: {
                commandSender.sendMessage("§9§l§m=]=======§2 Bungee§aCross §9§l§m========[=");
                commandSender.sendMessage(VariableStorage.getPrefix() + "跨服插件：§2Bungee§aCross");
                commandSender.sendMessage(VariableStorage.getPrefix() + "§6作者：§e" + BungeeCross.getAuthor());
                commandSender.sendMessage(VariableStorage.getPrefix() + "§9版本：§d" + BungeeCross.getVersion());
                commandSender.sendMessage(VariableStorage.getPrefix() + "§b您的版本为最新的");
                commandSender.sendMessage("§9§l§m=]=======§2 Bungee§aCross §9§l§m========[=");
            }
        }
    }
}
