package com.frontleaves.bungeecross.commands;

import com.frontleaves.bungeecross.configuration.VariableStorage;
import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.plugin.Command;
import org.jetbrains.annotations.NotNull;

/**
 * 查询服务器列表
 *
 * @author 筱锋xiao_lfeng
 * @version v1.0-SNAPSHOT
 * @since v1.0-SNAPSHOT
 */
public class ProxyServerListCommand extends Command {
    private StringBuilder serverList = null;

    public ProxyServerListCommand(String name) {
        super(name);
    }

    @Override
    public void execute(@NotNull CommandSender commandSender, String[] strings) {
        // 整理数据
        serverList = null;
        VariableStorage.getProxyServer().forEach((key, serverInfo) -> {
            if (serverList == null) {
                serverList = new StringBuilder("    §6" + serverInfo.getName());
            } else {
                serverList.append("§r, §6").append(serverInfo.getName());
            }
        });
        // 返回列表信息
        commandSender.sendMessage(VariableStorage.getPrefix() + "§e当前服务器如下：");
        commandSender.sendMessage(serverList.toString());
    }
}
