package com.frontleaves.bungeecross.commands;

import com.frontleaves.bungeecross.BungeeCross;
import com.frontleaves.bungeecross.configuration.VariableStorage;
import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.plugin.Command;
import org.jetbrains.annotations.NotNull;

import java.util.Random;

/**
 * 返回大厅指令
 *
 * @author 筱锋xiao_lfeng
 * @version v1.0-SNAPSHOT
 * @since v1.0-SNAPSHOT
 */
public class ReturnHubCommand extends Command {
    private final BungeeCross plugin;

    public ReturnHubCommand(String name, BungeeCross bungeeCross) {
        super(name);
        plugin = bungeeCross;
    }

    @Override
    public void execute(@NotNull CommandSender commandSender, String[] strings) {
        // 检查玩家所属服务器
        String playerName = commandSender.getName();
        if (commandSender instanceof ProxiedPlayer) {
            String userServerInfo = plugin.getProxy().getPlayer(playerName).getServer().getInfo().getName();
            if (VariableStorage.getLoginServer().contains(userServerInfo)) {
                commandSender.sendMessage(VariableStorage.getPrefix() + "登录服无权限传送");
            } else {
                Random random = new Random();
                int getKey = random.nextInt(VariableStorage.getLobbyServer().size());
                plugin.getProxy().getPlayer(playerName).connect(plugin.getProxy().getServerInfo((String) VariableStorage.getLobbyServer().get(getKey)));
            }
        } else {
            commandSender.sendMessage(VariableStorage.getPrefix() + "该指令只允许玩家使用");
        }
    }
}
