package com.frontleaves.bungeecross.events;

import com.frontleaves.bungeecross.BungeeCross;
import com.frontleaves.bungeecross.configuration.VariableStorage;
import net.md_5.bungee.api.event.ServerSwitchEvent;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.event.EventHandler;
import org.jetbrains.annotations.NotNull;

import java.util.Map;
import java.util.regex.Pattern;

/**
 * 玩家切换子服事件
 *
 * @author 筱锋xiao_lfeng
 * @version v1.0-SNAPSHOT
 * @since v1.0-SNAPSHOT
 */
public class PlayerCrossServerEvent implements Listener {
    private final BungeeCross plugin;

    public PlayerCrossServerEvent(BungeeCross bc) {
        plugin = bc;
    }

    @EventHandler
    public void onPlayerCrossServer(@NotNull ServerSwitchEvent event) {
        // 登录服务器默认不通知
        Map<String, Map<String, Object>> getServerConfiguration = VariableStorage.getProxyServerConfiguration();
        try {
            Map<String, Object> getFromServerConfiguration = getServerConfiguration.get(event.getFrom().getName());
            Map<String, Object> getToServerConfiguration = getServerConfiguration.get(event.getPlayer().getServer().getInfo().getName());
            if ((boolean) getFromServerConfiguration.get("leaveEnable")) {
                event.getFrom().getPlayers().forEach(proxiedPlayer -> {
                    String leaveServerMessage = String.valueOf(getFromServerConfiguration.get("leaveMessage"));
                    String message = Pattern.compile("%player%").matcher(leaveServerMessage).replaceAll(event.getPlayer().getName());
                    message = Pattern.compile("%server_display%").matcher(message).replaceAll(event.getFrom().getName());
                    proxiedPlayer.sendMessage(message);
                });
            }
            if ((boolean) getToServerConfiguration.get("joinEnable")) {
                event.getPlayer().getServer().getInfo().getPlayers().forEach(proxiedPlayer -> {
                    String joinServerMessage = String.valueOf(getToServerConfiguration.get("joinMessage"));
                    String message = Pattern.compile("%player%").matcher(joinServerMessage).replaceAll(event.getPlayer().getName());
                    message = Pattern.compile("%server_display%").matcher(message).replaceAll(event.getPlayer().getServer().getInfo().getName());
                    proxiedPlayer.sendMessage(message);
                });
            }
            System.out.print(VariableStorage.getPrefix() + "玩家 " + event.getPlayer().getName() + " 从 " + event.getFrom().getName() +" 跳转到 " + event.getPlayer().getServer().getInfo().getName());
        } catch (NullPointerException ignore) {
            System.out.print(VariableStorage.getPrefix() + "玩家 " + event.getPlayer().getName() + " 加入到服务器 " + event.getPlayer().getServer().getInfo().getName());

        }
    }
}
