package com.frontleaves.bungeecross.events;

import com.frontleaves.bungeecross.BungeeCross;
import com.frontleaves.bungeecross.configuration.VariableStorage;
import net.md_5.bungee.api.event.LoginEvent;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.event.EventHandler;
import org.jetbrains.annotations.NotNull;

import java.util.HashMap;
import java.util.Map;
import java.util.regex.Pattern;

/**
 * 玩家登录服务器事件
 *
 * @author 筱锋xiao_lfeng
 * @version v1.0-SNAPSHOT
 * @since v1.0-SNAPSHOT
 */
public class PlayerJoinProxyEvent implements Listener {
    private final BungeeCross plugin;

    public PlayerJoinProxyEvent(BungeeCross bc) {
        plugin = bc;
    }

    @EventHandler
    public void onPlayerJoinProxy(@NotNull LoginEvent event) {
        // 发送用户登录信息
        String loginServerMessage = VariableStorage.getJoinMessage();
        if (VariableStorage.isBungeeCordReminder()) {
            if (!VariableStorage.isBungeeSilent()) {
                Map<String, Map<String, Object>> getServerConfiguration = VariableStorage.getProxyServerConfiguration();
                plugin.getProxy().getPlayers().forEach(proxiedPlayer -> {
                    Map<String, Object> server = getServerConfiguration.get(proxiedPlayer.getServer().getInfo().getName());
                    if (((boolean) server.get("bungeeJoinServerReminder"))) {
                        String message = Pattern.compile("%player%").matcher(loginServerMessage).replaceAll(event.getConnection().getName());
                        proxiedPlayer.sendMessage(message);
                    }
                });
            }
        }
        String message = Pattern.compile("%player%").matcher(loginServerMessage).replaceAll(event.getConnection().getName());
        System.out.print(message);
    }
}
